module NoWWW
  class Middleware
    STARTS_WITH_WWW = /^www\./i
    IP_STRING = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/i

    def initialize(app)
      @app = app
    end

    def call(env)
      uri = URI.parse Rack::Request.new(env).url
      unless uri.host =~ STARTS_WITH_WWW || uri.host =~ IP_STRING
        uri.host = "www.#{uri.host}"
        puts "NoWWW: Redirected to #{uri.to_s}"
        [301, { 'Location' =>  uri.to_s}, ['Redirecting...']]
      else
        @app.call(env)
      end
    end
  end
end
